/* FILE: prob_recon_support.h                                                                    *
 * PURPOSE: This file contains helper functions for the CPISync (also used by PROBSync)          *
 * algorithm implementation in reconpalm3.cpp.                                                   *
 * DATE: 5/22/02                                                                                 *
 * CONSTANTS: none                                                                               *
 * MODULES: CPISync                                                                              *
 */

// Include Files
 #include "NTL/matrix.h"
 #include "NTL/mat_ZZ_p.h"
 #include "NTL/vec_ZZ.h"
 #include "NTL/ZZ.h"
 #include "NTL/ZZ_p.h"
 #include "NTL/vec_ZZ_p.h"
 #include <math.h>
 #include "NTL/vec_vec_ZZ_p.h"
 #include "NTL/ZZ_pX.h"
 #include "NTL/ZZ_pXFactoring.h"
 #include <stdlib.h>
 #include <time.h>


vec_ZZ_p compute_samplepoints(long numberof,ZZ_p& fieldminus1);
vec_ZZ_p calc_poly(vec_ZZ_p& set, vec_ZZ_p& samplepoints);
long calc_diff_ma_mb(vec_ZZ_p A, vec_ZZ_p B);
long calc_mabar(long mbar,long d);
long calc_mbbar(long mbar,long d);
mat_ZZ_p construct_vandermonde_matrix(const vec_ZZ_p& samplepoints,const vec_ZZ_p& RF, const vec_ZZ_p& bmatrix, const long mbar, const long d);
vec_ZZ_p construct_RHS_constant_vector(vec_ZZ_p RF,vec_ZZ_p samplepoints,long rank,long mbar, long d);
mat_ZZ_p makeA(mat_ZZ_p vmat,long rank,long mbar);
vec_ZZ_p makeB(mat_ZZ_p vmatrix,long rank,long mbar,long d);
vec_ZZ_p backsubstitutesolve(mat_ZZ_p mat, vec_ZZ_p bvec, long rank,long totalcoeffs);
int match_value(ZZ_pX PX,ZZ_pX QX,vec_ZZ_p PCEVALS,vec_ZZ_p EXTRASPS,vec_ZZ_p EXTRAEVALS);
vec_ZZ_p reconstruct(vec_ZZ_p B,long mm);