#include "\Palm\PalmDb\PalmDb.h"
#include "\Palm\PalmHashDb\PalmHashDb.h"
#include "\Palm\PalmMemoDb\PalmMemoDb.h"
#include "\Palm\PalmPolyDb\PalmPolyDb.h"


/* FUNCTION: closeDatabases                                                          *
 * PURPOSE: Closes the alphabetized document database, the insertion order document  *
 * database, the hash value database and the characteristic polynomial database.     *
 * DATE: 5/28/02                                                                     *
 * CONSTANTS: none                                                                   *
 * MODULES: PalmDb                                                                   */
void closeDatabases( DmOpenRef docDb, DmOpenRef idocDb, DmOpenRef hashDb, DmOpenRef polyDb )
{
	DmCloseDatabase( docDb );
	DmCloseDatabase( idocDb );
	DmCloseDatabase( hashDb );
	DmCloseDatabase( polyDb );
}


/* FUNCTION: deleteDatabases                                                                      *
 * PURPOSE: This function will delete all the databases associated with the SyncMemo application  *
 * from the PalmPilot.                                                                            *
 * DATE: 6/21/02                                                                                  *
 * CONSTANTS: The database names                                                                  *
 * MODULES: PalmDb                                                                                */
void deleteDatabases()
{
	LocalID databaseid;

	databaseid = DmFindDatabase( 0, "SyncDocDB" );			
	if (databaseid)
		DmDeleteDatabase( 0, databaseid );

	databaseid = DmFindDatabase( 0, "SyncIDocDB" );
	if (databaseid)
		DmDeleteDatabase( 0, databaseid );
						
	databaseid = DmFindDatabase( 0, "SyncHashDB" );
	if (databaseid)
		DmDeleteDatabase( 0, databaseid );
						
	databaseid = DmFindDatabase( 0, "SyncPolyDB" );
	if (databaseid)
		DmDeleteDatabase( 0, databaseid );
}


/* FUNCTION: openDatabases                                                                 *
 * PURPOSE: Given uninitialized pointers to the alphabetized database, the insertion order *
 * database, the hash value database and the polynomial database, this function opens each *
 * database and sets the pointers to the openeded databases, so that they can be used as   *
 * references for those databases.                                                         *
 * DATE: 5/28/02                                                                           *
 * CONSTANTS: none                                                                         *
 * MODULES: PalmDb                                                                         */
void openDatabases( DmOpenRef *doc, DmOpenRef *idoc, DmOpenRef *hash, DmOpenRef *poly )
{
	*doc = openDocDb();
	*idoc = openInsertionDocDb();
	*hash = openHashDb2();
	*poly = openPolyDb();
}
