' This is the Visual Basic script that controls the execution of the Automated Test Program.
' For a detailed description, look at the final report document, or simply browse the commented source code
' Created by: Avi Yaar 7/15/02


' Set the access path for the root directory of the research files
Dim ROOTPATH
ROOTPATH = "C:\SyncProj"
Dim PALMPATH
PALMPATH = "C:\Palm\YaarA"


' Get the windows Shell object
Set shell = CreateObject("WScript.Shell")
Set filesystem = CreateObject("Scripting.FileSystemObject")

Public Function RecompileApps()

	' Rebuild the Conduit
	shell.Run "msdev " + ROOTPATH + "\cconduit\SyncMe~1\SyncMemoCond.dsp /MAKE ""SyncMemoCond - Win32 Debug"" /REBUILD", True

	' Rebuild the PCMemo application
'	shell.Run "msdev " + ROOTPATH + "\testto~1\pcmemo\PCMemo.dsp /MAKE ""PCMemo - Win32 Debug"" /REBUILD"

	' Rebuild the PC automatic memo generator (ConsoleMemo)
	shell.Run "msdev " + ROOTPATH + "\testto~1\consol~1\ConsoleMemo.dsp /MAKE ""ConsoleMemo - Win32 Debug"" /REBUILD"

	' Rebuild the SyncMemo application
	shell.Run ROOTPATH + "\testto~1\automa~1\BuildCodeWarrior.vbs " + ROOTPATH + "\CPalm\SyncMemo\SyncMemo.mcp""", 0, True

	' Rebuild the Palm automatic memo generator (GenMemo)
	shell.Run ROOTPATH + "\testto~1\automa~1\BuildCodeWarrior.vbs " + ROOTPATH + "\CPalm\GenMemo\GenMemo.mcp""", 0, True



End Function



Public Function InstallApps()
	' delete any old copies of the applications that may already be in the install directory
	If filesystem.FolderExists(PALMPATH + "\Install") Then 
		If filesystem.GetFolder(PALMPATH + "\Install").Files.Count <> 0 Then
			filesystem.DeleteFile PALMPATH + "\Install\*.*"
		End If
	End If

	' set the new copies of the applications to install
	shell.Run ROOTPATH + "\testto~1\Instal~1\debug\Installer ""Avi Yaar"" """ + ROOTPATH + "\cpalm\syncmemo\syncmemo.prc"""

	shell.Run ROOTPATH + "\testto~1\Instal~1\debug\Installer ""Avi Yaar"" """ + ROOTPATH + "\cpalm\genmemo\genmemo.prc"""

	shell.Run ROOTPATH + "\testto~1\Instal~1\debug\Installer ""Avi Yaar"" """ + ROOTPATH + "\POSE\randomDB.pdb"""


End Function



Public Function UpdateParameters( operationtype, nummemos, memosize, memodifferences, roundcount, bound )

	roundcount = roundcount + 1

	Select Case operationtype
		case 1									'OPERATION 1: Decrement (by 1) number of memos generated 
			nummemos = nummemos - 1			
			If nummemos < bound Then
				operationtype = 0
			End If
		
		case 2
			nummemos = nummemos + 1				'OPERATION 2: Increment (by 1) number of memos generated
			If nummemos >= bound Then
				operationtype = 0
			End If
				
		case 3
			memosize = memosize - 5		 		'OPERATION 3: Decrement memo sizes by 5
			If memosize <= bound Then
				operationtype = 0 
			End If
				
		case 4
			memosize = memosize + 5				'OPERATION 4: Increment memo sizes by 5
			If memosize >= bound Then
				operationtype = 0
			End If	
		
		case 7									'OPERATION 7: Add 5 to the number of memos generated 
			nummemos = nummemos + 5
			If nummemos >= bound Then
				operationtype = 0
			End If

		case 8									'OPERATION 8: Increment the constant DIFFERENCES by 5
			Shell.Run ROOTPATH + "\testto~1\ConstC~1\Debug\ConstChange.exe """ + ROOTPATH + "\Source\Common\Constants.h"" ""DIFFERENCES"" 1 5"
			If roundcount >= bound Then
				operationtype = 0
			End If
			
		case 9									'OPERATION 9: Do Nothing here, just wait as the rounds pass by
			If roundcount >= bound Then
				operationtype = 0
			End If

		case 10									'OPERATION 10: Increase the differences between the sets by 4
			memodifferences = memodifferences + 4
			If memodifferences >= bound Then
				operationtype = 0
			End If

	End Select


End Function



' Step 0: Initialize the test type variable, and the number of rounds
operationtype = 9
nummemos = 95
memosize = 120
memodifferences = 0
bound = 11
roundcount = 0


Do
' TIMED SECTION - BEGIN Make sure that this section takes exactly 45 seconds
	starttime = Second( Time() )

' Step 1: Recompile the applications

	RecompileApps()


' Step 2: Set the new Palm applications to install to the Palm at the next hotsync

	InstallApps()


' Step 3: Set the installation conduit as active and wait for the hotsync to finish
	shell.Run "C:\CDK402\Common\Bin\C4.02\condswitch.exe /d /i C:\CDK402\Common\Bin\C4.02\InstallOnly.txt /r"

	endtime = Second( Time() )

	' These statements will pause the computer for the remainder of the 45 second time block, or
	' if the time block has exceeded 45 seconds (but not more than 1 min) then they will flag an error
	If endtime > starttime Then
		If endtime - starttime > 45 Then
			MsgBox "Time Synchronization Error... compile took too long, round: " + CStr(round)
		Else
			shell.Popup "Waiting for installation hotsync... round: " + CStr(roundcount), 45 - (endtime - starttime)
		End If
	Else
		If endtime + 60 - starttime > 45 Then
			MsgBox "Time Synchronization Error... compile took too long, round: " + CStr(round)
		Else
			shell.Popup "Waiting for installation hotsync... round: " + CStr(roundcount), 45 - (endtime + 60 - starttime)
		End If
	End If


' TIMED SECTION - END This section should have taken exactly 45 seconds

' TIMED SECTION - BEGIN This section should take exactly 60 seconds
	starttime = Second( Time() )
	startmin = Minute( Time() )
	
' Step 4: Create the memos to be synchronized using the ConsoleMemo program

	shell.Run ROOTPATH + "\testto~1\consol~1\debug\ConsoleMemo 0 " + CStr(nummemos) + " " + CStr(memosize) + " " + CStr(memodifferences),  0, True


' Step 5: Set the SyncMemo conduit as active and wait for the hotsync to finish
	shell.Run "C:\CDK402\Common\Bin\C4.02\condswitch.exe /d /i C:\CDK402\Common\Bin\C4.02\SyncMemoOnly.txt /r"

	endtime = Second( Time() )
	endmin = Minute( Time() )

	' These statements will pause the computer for the remainder of the 60 second time block
	If endtime <> starttime Then
		If endtime > starttime Then
			shell.Popup "Waiting for synchronization hotsync... round: " + CStr(roundcount), 60 - (endtime - starttime)
		Else
			shell.Popup "Waiting for synchronization hotsync... round: " + CStr(roundcount), 60 - (endtime + 60 - starttime)
		End If
	Else
		If endmin - startmin <> 1 AND endmin - startmin <> -59 AND endmin - startmin <> 0 Then
			MsgBox "Time Synchronization Error... hotsync took too long, round: " + CStr(roundcount)
		End If
		If startmin = endmin Then
			shell.Popup "Waiting for synchronization hotsync... round: " + CStr(roundcount), 60
		End If
	End If
			

' TIMED SECTION - END This section should have taken exactly 60 seconds


' Step 6: Update the parameters for this round

	UpdateParameters operationtype, nummemos, memosize, memodifferences, roundcount, bound 


Loop Until operationtype = 0

MsgBox "Automatic Testing Completed"